//Estructura de datos
var contabilidad;

//Funciones del Men Archivo

function abrir(){  //{{{
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, "Selecciona un Archivo", nsIFilePicker.modeOpen);
    fp.appendFilter("Ficheros XML", "*.xml");
    fp.appendFilter("Todos los Ficheros", "*.*");	//Esto es IMPRESCINDIBLE. No lo quites.
    var res=fp.show();
      if (res == nsIFilePicker.returnOK){
      
	//Cargamos el fichero XMl y lo procesamos para generar la estructura JavaScript (Cgate!!)
	pathFichero = "file://" + fp.fileURL.filePath;
	docXML = document.implementation.createDocument("","",null);
	docXML.async = false; //Por si tarda en cargar
	docXML.load(pathFichero);
	//Aqu hay que abrir un ProgressMeter
	contabilidad = new Contabilidad(docXML);  //Creamos la nueva Contabilidad
	
	//Este dato slo est aqu
	contabilidad.fichero = fp.file;	//Ojo, es del tipo nsIFile

	//Cambiamos el ttulo de la ventana
	window.title = "eContab - " + contabilidad.empresa + " - " + contabilidad.referencia;
		
	//Cargamos la ventana principal en el marco
	cargarVentanaPrincipal();
      }
} //}}}

function nuevo(){  //{{{
//Crea una nueva contabilidad, vaca
  contabilidad = new Contabilidad(null);
  cargarVentanaPrincipal();
} //}}}

function cerrar(){ //{{{
  if (contabilidad.modificada)
    if(!confirm("No has guardado la contabilidad!\n Si la cierras, PERDERS los cambios.\n\n Realmente quieres CERRAR?"))
      return false;	// No funciona al pulsar el icono de cerrar de la ventana. Por qu?
  contabilidad = null;

  //Cambiamos el ttulo de la ventana
  window.title = "eContab - Contabilidad Flexible";

  //Desactivamos los mens
  desactivaMenu();
	
  //Descargamos el frame principal
  document.getElementById("principal").setAttribute("src", "");
	
  return true;
} //}}}

function guardar(parametro){ //{{{
//Guarda la contabilidad en un fichero con formato XML
//El parmetro, si existe, indica el periodo a descargar.

	if (contabilidad.fichero != null){
		var contenido = contabilidad.verXML(parametro);	//Si falla, no habremos tocado el fichero
		try{
			// Ref. www.captain.at/programming/xul
			var fichero = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			//fichero.initWithPath( contabilidad.fichero);
			fichero.initWithFile(contabilidad.fichero);
			if (fichero.exists() == false)
				fichero.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420);
			
			var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream );
			outputStream.init( fichero, 0x04 | 0x08 | 0x20, 420, 0);
			outputStream.write(contenido, contenido.length);
			outputStream.close();
			alert("La contabilidad se ha guardado con xito en el fichero " + fichero.path);
			contabilidad.modificada = false;
		}
		catch(ex){
			alert(ex);
		}
	}
	else{
		guardarComo(null);
	}
} //}}}

function guardarComo(parametro){ //{{{
//Permite indicar un fichero donde guardar la contabilidad
//El parmetro, si existe, indica el periodo a descargar.
  		try{
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		  	fp.init(window, "Selecciona un Archivo", nsIFilePicker.modeSave);
			fp.appendFilter("Ficheros de XML", "*.xml");
			fp.appendFilter("Todos los Ficheros", "*.*");	//Esto es IMPRESCINDIBLE. No lo quites.
			var res=fp.show();
			if ((res == nsIFilePicker.returnOK) || (res == nsIFilePicker.returnReplace)){
				//fichero = "file://" + fp.fileURL.filePath;
				//contabilidad.fichero = fichero;
				contabilidad.fichero = fp.file;		//Ojo, es un objeto nsILocalFile
				guardar(parametro);
			}
		}
		catch(ex){
		  	alert (ex);
		}
} //}}}

function salir( ){ //{{{

  if (contabilidad == null) window.close();
  if (contabilidad.modificada){
    if(confirm("No has guardado la contabilidad!\n\n Realmente quieres SALIR?"))
      window.close();
    else
      return false;
  }
  else
    window.close();
    
} //}}}

function autoguardar(){ //{{{
//Guarda una copia de seguridad del fichero de contabilidad

  if (contabilidad.fichero != null){
    var contenido = contabilidad.verXML();	//Si falla, no habremos tocado el fichero
    try{
      // Ref. www.captain.at/programming/xul
      var fichero = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      //Hay que construir el nombre del fichero
      var nombre = contabilidad.fichero.path;
      alert(nombre);
      //fichero.initWithFile( contabilidad.fichero ); Esta llamada no puede ser, debe tener como parmetro el nombre
      if (fichero.exists() == false)
	fichero.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420);
			
      var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream );
      outputStream.init( fichero, 0x04 | 0x08 | 0x20, 420, 0);
      outputStream.write(contenido, contenido.length);
      outputStream.close();
    }
    catch(ex){
      alert(ex);
    }
  }
} //}}}

//Funciones del men Operaciones
var fechaInicio;
var fechaFin;

function descargarCuentas(){/*{{{*/
//Descarga a un fichero el plan de cuentas, clientes, proveedores, predefinidos, etc. 
// y los asientos correspondientes a un periodo de tiempo (supuestamente ser un ao)

  window.openDialog('chrome://econtab/content/descarga.xul','descarga', 'chrome,dialog,modal');
  var parametro = new Object();
  parametro.fechaInicio = fechaInicio;
  parametro.fechaFin = fechaFin;
  guardarComo(parametro);

}/*}}}*/

function cerrarCuentas(){/*{{{*/
//Salda todas las cuentas de Ingresos y Gastos a una fecha concreta, 
// cargando al da siguiente sus saldos en la cuenta de PyG.
// Este asiento de cargo se crea con el nombre "Asiento de Apertura"

  //Aviso sobre la prdida de informacin y conveniencia de descargar.
  if (!confirm("La operacin de Cierre de Cuentas resume todos los asientos de de un periodo en un nico Asiento de Apertura.\nEsto supone una PRDIDA DE INFORMACIN!.\n Es conveniente realizar previamente una \"Descarga de Cuentas\".\nEst seguro de que quiere continuar?"))
    return;

  if (!contabilidad.idCuentaPyG){
    alert("No est definida la cuenta de Prdidas y Ganancias.\n Vaya a la pestaa de Parmetros para definirla");
    exit;
  }
    
  //Captura de datos (fecha de cierre)
  window.openDialog('chrome://econtab/content/cierre.xul','cierre', 'chrome,dialog,modal');

  //Proceso
  //Preparamos las cuentas para saldarlas
  Cuenta.prototype.prepararSaldar = prepararSaldarCuenta;
  Cuenta.prototype.cerrar = cerrarCuenta;
  
  //Ponemos todos los saldos de las cuentas a cero
  for (var i=0; i<contabilidad.cuenta.length; i++)
    contabilidad.cuenta[i].prepararSaldar();
  
  //Saldamos todas las cuentas finales
  for (var i=0; i<contabilidad.asiento.length; i++)
    if ((fechaInicio <= contabilidad.asiento[i].fecha) && (contabilidad.asiento[i].fecha <= fechaFin))
      for (var j=0; j<contabilidad.asiento[i].apunte.length; j++)
	contabilidad.verCuentaPorId(contabilidad.asiento[i].apunte[j].idCuenta).saldo += eval(contabilidad.asiento[i].apunte[j].importe);

  //Creamos el Asiento de Apertura
  var asientoApertura = contabilidad.nuevoAsiento();
  asientoApertura.nombre = "Asiento de Apertura";
  asientoApertura.fecha = new Date(fechaFin.getYear() + 1900, fechaFin.getMonth(), fechaFin.getDate() + 1);
  asientoApertura.notas = "Generado automticamente. Corresponde al periodo ";
  asientoApertura.notas = asientoApertura.notas + fechaInicio.getDate() + "/" + (fechaInicio.getMonth() + 1) + "/" + (fechaInicio.getYear() + 1900);
  asientoApertura.notas = asientoApertura.notas + " - " + fechaFin.getDate() + "/" + (fechaFin.getMonth() + 1) + "/" + (fechaFin.getYear() + 1900);
  //Creamos un Apunte por cada cuenta, salvo las de Ingresos o Gastos, que se acumulan en la cuenta de PyG
  var apuntePyG = asientoApertura.nuevoApunte();
  apuntePyG.idCuenta = contabilidad.idCuentaPyG;
  apuntePyG.importe = 0;
  for (var i=0; i<contabilidad.cuenta.length; i++)
    contabilidad.cuenta[i].cerrar(asientoApertura);

  //Borramos los asientos del periodo. No podemos hacerlo con un for, por la estrategia del mtodo borrarAsiento,
  // que modifica el array de asientos.
  var seguir = true;
  while (seguir){
    seguir = false;
    for (var i=0; i<contabilidad.asiento.length; i++)
      if ((fechaInicio <= contabilidad.asiento[i].fecha) && (contabilidad.asiento[i].fecha <= fechaFin)){
	seguir = true;
	contabilidad.borrarAsiento(contabilidad.asiento[i]);
	break;
      }
    }
      

  contabilidad.modificada = true;
  
  //Aviso de proceso completado
  alert("El proceso de Cierre de Cuentas se ha completado con xito. (O eso creo)");

}/*}}}*/

function prepararSaldarCuenta(){/*{{{*/
  this.saldo = 0;
  for (var i=0; i<this.cuenta.length; i++)
    this.cuenta[i].prepararSaldar();
}/*}}}*/

function cerrarCuenta(asientoApertura){/*{{{*/
  if (this.fin){
    //Si es de Ingresos o Gastos, anotamos el saldo en el apunte de PyG
    if (this.tipo == "Ingresos")
      asientoApertura.apunte[0].importe += this.saldo;
    if (this.tipo == "Gastos")
      asientoApertura.apunte[0].importe -= this.saldo;
    //Si no es de PyG, creamos un nuevo apunte para la cuenta
    if ((this.tipo != "Ingresos") && (this.tipo != "Gastos")){
      if (Math.abs(this.saldo) >= 0.1){ 
	var apunte = asientoApertura.nuevoApunte();
	apunte.idCuenta = this.id;
	apunte.importe = Math.round(this.saldo * 100)/100;
      }
    }
  }
  else{
    //Cerramos sus subcuentas
    for (var i=0; i<this.cuenta.length; i++)
      this.cuenta[i].cerrar(asientoApertura);
  }
}/*}}}*/

//Funciones Auxiliares

function cargarVentanaPrincipal(){ //{{{
  activaMenu();
  document.getElementById("principal").setAttribute("src", "chrome://econtab/content/principal.xul"); 
}  //}}}

function activaMenu(){  //{{{
	//Activa los mens (Contabilidad Abierta)
	document.getElementById("menuAbrir").setAttribute("disabled", "true");
	document.getElementById("menuNuevo").setAttribute("disabled", "true");
	document.getElementById("menuCerrar").setAttribute("disabled", null);
	document.getElementById("menuGuardar").setAttribute("disabled", null);
	document.getElementById("menuGuardarComo").setAttribute("disabled", null);

	document.getElementById("menuOperaciones").setAttribute("disabled", null);
	//document.getElementById("menuAsientos").setAttribute("disabled", null);

} //}}}

function desactivaMenu(){ //{{{
	//Desctiva los mens (Contabilidad Cerrada)
	document.getElementById("menuAbrir").setAttribute("disabled", null);
	document.getElementById("menuNuevo").setAttribute("disabled", null);
	document.getElementById("menuCerrar").setAttribute("disabled", "true");
	document.getElementById("menuGuardar").setAttribute("disabled", "true");
	document.getElementById("menuGuardarComo").setAttribute("disabled", "true");
	
	document.getElementById("menuOperaciones").setAttribute("disabled", "true");
	//document.getElementById("menuAsientos").setAttribute("disabled", "true");


} //}}}

