// Variables Globales/*{{{*/
var contabilidad = parent.parent.contabilidad;

var estadoIUGenerales = "Consulta";
var estadoIUTiposAsiento = "Consulta";
var tipoAsientoSeleccionado;

var observerCuenta = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("cuenta");
    return flavours;
  },
  onDrop: function (evt,dropdata,session){
    if (estadoIUGenerales == "Edicin"){ //Solo actualizamos si estamos editando
      //La cuenta de PyG solo puede ser final y de pasivo.
      if ((parent.cuentaSeleccionada.fin) && (parent.cuentaSeleccionada.tipo == "Pasivo")){
	evt.target.setAttribute("value", parent.cuentaSeleccionada.nombre);
	evt.target.setAttribute("tooltiptext", parent.cuentaSeleccionada.nombre);
	evt.target.cuenta = parent.cuentaSeleccionada;
      }
      else
	alert("La cuenta de Prdidas y Ganancias (PyG) debe ser FINAL y de PASIVO.");
    }
  },
  onDragOver: function (evt, flav, dragSession){
    //Esta funcin hace falta aunque no haga nada.
  }
};  //Ojo a las , y al ;
/*}}}*/

function iniciar(){/*{{{*/
//Acciones al cargar el formulario
  mostrar();
  verTiposAsiento();
}/*}}}*/

function botonEditarGenerales(){/*{{{*/
//Respuesta al botn Editar
  cambiarEstadoGenerales("Edicin");
}/*}}}*/

function botonAceptarGenerales(){/*{{{*/
//Guardamos los valores modificados
  contabilidad.empresa = document.getElementById("textboxEmpresa").value;
  contabilidad.referencia = document.getElementById("textboxReferencia").value;
  contabilidad.moneda = document.getElementById("textboxMoneda").value;
  if (document.getElementById("labelCuentaPyG").cuenta)
    contabilidad.idCuentaPyG = document.getElementById("labelCuentaPyG").cuenta.id;
  else
    contabilidad.idCuentaPyG = "";
  //Comprobamos los dgitos de PGC
  if (eval(document.getElementById("textboxDigitosPGC").value) < 5)
    alert("El nmero de dgitos PGC debe ser UN NMERO MAYOR QUE CUATRO.");
  else
    contabilidad.digitosPGC = eval(document.getElementById("textboxDigitosPGC").value);

  contabilidad.modificada = true;

  //Refrescamos el rbol de cuentas
  parent.verCuentas();
  
  botonCancelarGenerales();
 }/*}}}*/

function botonCancelarGenerales(){/*{{{*/
//Respuesta al botn Cancelar
  cambiarEstadoGenerales("Consulta");
  mostrar();
  
}/*}}}*/

function cambiarEstadoGenerales(estado){/*{{{*/
//Cambia el estado del Interfaz de Usuario
  estadoIUGenerales = estado;
  switch (estado){
    //Modos Pasivos
    case "Consulta":
      document.getElementById("botonEditarGenerales").removeAttribute("disabled");
      document.getElementById("botonAceptarGenerales").setAttribute("disabled", "true");
      document.getElementById("botonCancelarGenerales").setAttribute("disabled", "true");
      document.getElementById("textboxEmpresa").setAttribute("disabled","true");
      document.getElementById("textboxReferencia").setAttribute("disabled","true");
      document.getElementById("textboxMoneda").setAttribute("disabled","true");
      document.getElementById("textboxDigitosPGC").setAttribute("disabled","true");
      break;

    //Modos Activos
    case "Insercin":
    case "Edicin":
      document.getElementById("botonEditarGenerales").setAttribute("disabled","true");
      document.getElementById("botonAceptarGenerales").removeAttribute("disabled");
      document.getElementById("botonCancelarGenerales").removeAttribute("disabled");
      document.getElementById("textboxEmpresa").removeAttribute("disabled");
      document.getElementById("textboxReferencia").removeAttribute("disabled");
      document.getElementById("textboxMoneda").removeAttribute("disabled");
      document.getElementById("textboxDigitosPGC").removeAttribute("disabled");
      document.getElementById("textboxEmpresa").focus();
      break;
      
    default:
      alert("El estado " + estado + " es desconocido");
  }
}/*}}}*/

function mostrar(){/*{{{*/
//Carga el formulario con los datos

  document.getElementById("textboxEmpresa").value = contabilidad.empresa;
  document.getElementById("textboxReferencia").value = contabilidad.referencia;
  if (contabilidad.fichero)
	document.getElementById("labelFichero").value = contabilidad.fichero.path;
  document.getElementById("textboxMoneda").value = contabilidad.moneda;
  document.getElementById("textboxDigitosPGC").value = contabilidad.digitosPGC;
  document.getElementById("labelCuentaPyG").idCuenta = contabilidad.idCuentaPyG;
  if (contabilidad.idCuentaPyG)
    document.getElementById("labelCuentaPyG").value = contabilidad.verCuentaPorId(contabilidad.idCuentaPyG).nombre;
}/*}}}*/

function botonEditarTipoAsiento(){/*{{{*/
//Edita el Tipo de Asiento seleccionado
  cambiarEstadoTipoAsiento("Edicin");
}/*}}}*/

function botonNuevoTipoAsiento(){/*{{{*/
//Respuesta al botn Nuevo del formulario de Tipo de Asiento
  cambiarEstadoTipoAsiento("Insercin");
}/*}}}*/

function botonBorrarTipoAsiento(){/*{{{*/
//Respuesta al botn Borrar del formulario de Tipo de Asiento
  if (document.getElementById("listboxTiposAsiento").selectedItem){;
    //Comprobamos que no existan asientos con su tipo
    if (contabilidad.hayAsientosTipo(tipoAsientoSeleccionado)){
      alert("En la contabilidad hay asientos del tipo " + tipoAsientoSeleccionado.nombre + ".\nNO SE PUEDE BORRAR!");
      return;
    }
    if(confirm("Estas segura/o de que quieres BORRAR este Tipo de Asiento?")){
      contabilidad.borrarTipoAsiento(tipoAsientoSeleccionado);
      contabilidad.modificada = true;
      verTiposAsiento();
    }
  }
  botonCancelarTiposAsiento();
}/*}}}*/

function botonAceptarTipoAsiento(){/*{{{*/
//Respuesta al botn Aceptar del formulario de Tipo de Asiento

  var tipoAsiento;
  if (estadoIUTiposAsiento == "Insercin"){
    tipoAsiento = new Object();
    contabilidad.maxIdTipoAsiento++;
    tipoAsiento.id = contabilidad.maxIdTipoAsiento;
    contabilidad.tipoAsiento[contabilidad.tipoAsiento.length] = tipoAsiento;
  }
  else
    tipoAsiento = tipoAsientoSeleccionado;
  
  tipoAsiento.nombre = document.getElementById("textboxNombreTipoAsiento").value; 
  if (document.getElementById("checkboxFacturaTipoAsiento").checked)
    tipoAsiento.factura = "true"; 
  else
    tipoAsiento.factura = "false"; 

  contabilidad.modificada = true;
  verTiposAsiento();
  botonCancelarTipoAsiento();
}/*}}}*/

function botonCancelarTipoAsiento(){/*{{{*/
//Respuesta al botn Cancelar del formulario de Tipo de Asiento
  cambiarEstadoTipoAsiento("Consulta");
}/*}}}*/

function cambiarEstadoTipoAsiento(estado){/*{{{*/
//Cambia el estado del Interfaz de Usuario de Tipo Asiento
  estadoIUTiposAsiento = estado;
  switch (estado){
    //Modos Pasivos
    
    case "Consulta":
      document.getElementById("textboxNombreTipoAsiento").setAttribute("disabled","true");
      document.getElementById("checkboxFacturaTipoAsiento").setAttribute("disabled","true");
      document.getElementById("botonEditarTipoAsiento").removeAttribute("disabled");
      document.getElementById("botonBorrarTipoAsiento").removeAttribute("disabled");
      document.getElementById("botonNuevoTipoAsiento").removeAttribute("disabled");
      document.getElementById("botonAceptarTipoAsiento").setAttribute("disabled","true");
      document.getElementById("botonCancelarTipoAsiento").setAttribute("disabled","true");
      break;

    //Modos Activos
    case "Insercin":
      document.getElementById("textboxNombreTipoAsiento").value = "";
      document.getElementById("checkboxFacturaTipoAsiento").removeAttribute("checked");
    case "Edicin":
      document.getElementById("textboxNombreTipoAsiento").removeAttribute("disabled");
      document.getElementById("checkboxFacturaTipoAsiento").removeAttribute("disabled");
      document.getElementById("botonEditarTipoAsiento").setAttribute("disabled","true");
      document.getElementById("botonBorrarTipoAsiento").setAttribute("disabled","true");
      document.getElementById("botonNuevoTipoAsiento").setAttribute("disabled","true");
      document.getElementById("botonAceptarTipoAsiento").removeAttribute("disabled");
      document.getElementById("botonCancelarTipoAsiento").removeAttribute("disabled");
      document.getElementById("textboxNombreTipoAsiento").focus();

      break;
      
    default:
      alert("El estado " + estado + " es desconocido");
  }
}/*}}}*/

function verTiposAsiento(){/*{{{*/
  //Cargamos los tipos de Asiento
  listboxTiposAsiento = document.getElementById("listboxTiposAsiento");
  while (listboxTiposAsiento.removeItemAt(2)); //Borramos la lista
 
  //Los ordenamos
  contabilidad.tipoAsiento.sort(ordenarTiposAsiento);
  //Los presentamos
  for (var i=0; i<contabilidad.tipoAsiento.length; i++){
    listitem = document.createElement("listitem");
    listcellNombre = document.createElement("listcell");
    listcellNombre.setAttribute("label", contabilidad.tipoAsiento[i].nombre);
    listcellFactura = document.createElement("listcell");
    if (contabilidad.tipoAsiento[i].factura)
      listcellFactura.setAttribute("label", "S");
    else
      listcellFactura.setAttribute("label", "No");
    listitem.appendChild(listcellNombre);
    listitem.appendChild(listcellFactura);
    //Y le aadimos el puntero al propio Tipo de Asiento
    listitem.tipoAsiento = contabilidad.tipoAsiento[i];
    listboxTiposAsiento.appendChild(listitem);
  }
}/*}}}*/

function ordenarTiposAsiento(tipoAsiento1, tipoAsiento2){/*{{{*/
//Una sencilla funcin para ordenar los tipos de asiento por su nombre
  if (tipoAsiento1.nombre >= tipoAsiento2.nombre) return 1;
  else return -1;
}/*}}}*/

function mostrarTipoAsiento(){/*{{{*/
//Carga los datos del tipo de asiento en el formulario de edicin
  if (document.getElementById("listboxTiposAsiento").selectedItem)
    if (estadoIUTiposAsiento == "Consulta"){
      tipoAsientoSeleccionado = document.getElementById("listboxTiposAsiento").selectedItem.tipoAsiento;
      document.getElementById("textboxNombreTipoAsiento").value = tipoAsientoSeleccionado.nombre;
      if (tipoAsientoSeleccionado.factura)
	document.getElementById("checkboxFacturaTipoAsiento").setAttribute("checked", "true");
      else
	document.getElementById("checkboxFacturaTipoAsiento").removeAttribute("checked");
    }
}/*}}}*/

